#ifndef KEY_H
#define KEY_H
#ifdef __cplusplus
extern "C" {
#endif

#include "lib/gba.h"


//---------------------------------------------------------------------------
#define KEY_MAX_BTN_CNT		10
#define KEY_REPEAT_CNT		10


enum {
	SYS_KEY_A = 0x00,
	SYS_KEY_B,
	SYS_KEY_SL,
	SYS_KEY_ST,
	SYS_KEY_RI,
	SYS_KEY_LE,
	SYS_KEY_UP,
	SYS_KEY_DO,
	SYS_KEY_R,
	SYS_KEY_L,
};

//---------------------------------------------------------------------------
typedef struct {
	u32 tmp[KEY_MAX_BTN_CNT];	// {^̔p
	u32 cnt;					// ݂̃L[
	u32 trg;					// ꂽL[
	u32 off;					// ꂽL[
	u32 rep;					// s[gL[
	s32 repCnt;					// s[gJEg
} ST_KEY;


//---------------------------------------------------------------------------
EWRAM_CODE void KeyInit(void);
IWRAM_CODE void KeyExec(void);

EWRAM_CODE u16  KeyGetCnt(void);
EWRAM_CODE u16  KeyGetTrg(void);
EWRAM_CODE u16  KeyGetOff(void);
EWRAM_CODE u16  KeyGetRep(void);

IWRAM_CODE bool KeyIsTrgA(void);
IWRAM_CODE bool KeyIsTrgB(void);
IWRAM_CODE bool KeyIsTrgL(void);
IWRAM_CODE bool KeyIsTrgR(void);


#ifdef __cplusplus
}
#endif
#endif
