#include "rpc.h"
#include "bg.h"
#include "key.h"
#include "irq_arm.h"

//---------------------------------------------------------------------------
ST_RPC Rpc;


//---------------------------------------------------------------------------
EWRAM_CODE void RpcInit(void)
{
	_Memset(&Rpc, 0x00, sizeof(ST_RPC));
}
//---------------------------------------------------------------------------
IWRAM_CODE void RpcExec(void)
{
	if(IrqSerialIsUse() == TRUE)
	{
		return;
	}


	if(KeyIsTrgL() == TRUE)
	{
		Rpc.var++;
	}

	bool isA = KeyIsTrgA();
	bool isB = KeyIsTrgB();
	bool isR = KeyIsTrgR();

	if(isA == FALSE && isB == FALSE && isR == FALSE)
	{
		return;
	}

	if(isA == TRUE)
	{
		char buf[40];
		_Sprintf(buf, "/var/write %d", Rpc.var);

		RpcSerial(buf);
	}

	if(isB == TRUE)
	{
		RpcSerialVar("/var/read", &Rpc.var);
	}

	if(isR == TRUE)
	{
		if(Rpc.isLED1 == FALSE)
		{
			RpcSerial("/myled1/write 1");
			Rpc.isLED1 = TRUE;
		}
		else
		{
			RpcSerial("/myled1/write 0");
			Rpc.isLED1 = FALSE;
		}
	}

	IrqSerialReady();
}
//---------------------------------------------------------------------------
IWRAM_CODE void RpcDraw(void)
{
	BgDrawPrintf(0, 0, "RPC TEST");

	if(Rpc.isLED1 == TRUE) BgDrawPrintf(1, 3, "MBED LED1 ON ");
	else                   BgDrawPrintf(1, 3, "MBED LED1 OFF");

	BgDrawPrintf(1, 4, "VAR = %08X(%d)", Rpc.var, Rpc.var);

	BgDrawPrintf(1,  7, "A : /var/write");
	BgDrawPrintf(1,  8, "B : /var/read");
	BgDrawPrintf(1,  9, "L : var count up");
	BgDrawPrintf(1, 11, "R : /myled1/write 1 or 0");
}
//---------------------------------------------------------------------------
IWRAM_CODE void RpcSerial(char* str)
{
	IrqSerialAddCmdStart();

	s32 i, cnt = _Strlen(str) / 4 + 1;

	for(i=0; i<cnt; i++)
	{
		IrqSerialAdd(*(u32*)(&str[i*4]));
	}

	IrqSerialAddCmdEnd();
}
//---------------------------------------------------------------------------
// mbed̕ϐǂݏoR}h̔s
IWRAM_CODE void RpcSerialVar(char* str, u32* r)
{
	RpcSerial(str);

	// i[AhXœo^܂
	IrqSerialAdd((u32)r);
}
